<template>
  <div>
    <div class="leakage-top">
      <div style="color: #666666"></div>

      <div class="operate-btn">
      <delids :multipleSelection2="multipleSelection"  @del="del()"
          >删除</delids> 
        <el-button type="primary" @click="refresh">刷新</el-button>
        <el-button type="primary" @click="block = !block">查询</el-button>
        <el-button type="primary" @click="exportData">导出</el-button>
      </div>
    </div>
    <el-form
      class="search-div"
      v-if="block"
      :model="leakyCableForm"
      :inline="true"
      size="mini"
    >
      <el-form-item label="漏缆描述：">
        <el-input
          placeholder="请输入漏缆描述"
          v-model="leakyCableForm.leakyCableDescribe"
          clearable
        >
        </el-input>
      </el-form-item>
      <el-form-item label="漏缆编号：">
        <el-input
          placeholder="请输入漏缆编号"
          v-model="leakyCableForm.leakyCableCode"
          clearable
        >
        </el-input>
      </el-form-item>
      <el-form-item label="漏缆型号：">
        <el-select
          placeholder="请选择漏缆型号"
          v-model="leakyCableForm.leakyCableMode"
          clearable
        >
          <el-option
            v-for="item in equipTypeList"
            :key="item.leakyCableMode"
            :label="item.leakyCableMode"
            :value="item.leakyCableMode"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="所在铁路线：">
        <el-select
          placeholder="请选择所在铁路线"
          v-model="leakyCableForm.wayId"
          clearable
          @change="changerailWay()"
        >
          <el-option
            v-for="item in railWaySelect"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="所在站点：">
        <el-select
          placeholder="请选择所在站点"
          v-model="leakyCableForm.siteId"
          @change="changesite()"
          clearable
        >
          <el-option
            v-for="item in stationSelect2"
            :key="item.id"
            :label="item.siteName"
            :value="item.id"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="所在FSU：">
        <el-select
          placeholder="请选择所在FSU"
          v-model="leakyCableForm.fsuId"
          @change="changefsu()"
          clearable
        >
          <el-option
            v-for="item in fsuSelect2"
            :key="item.id"
            :label="item.equipName"
            :value="item.id"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="所在监测设备：">
        <el-select
          placeholder="请选择所在监测设备"
          v-model="leakyCableForm.monitor"
          clearable
        >
          <el-option
            v-for="item in monitor2"
            :key="item.id"
            :label="item.equipName"
            :value="item.id"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button class="seabtn" @click="searchQuery()">查询</el-button>
        <el-button class="seabtn" @click="reset()">重置</el-button>
      </el-form-item>
    </el-form>
    <el-table
      ref="multipleTable"
      class="statistics-table"
      :data="tableData"
      tooltip-effect="dark"
      style="width: 100%"
      :row-class-name="tableRowClassName"
      :row-style="{ height: '50px' }"
      :header-cell-style="{
        background: '#eaf1fe',
        color: '#000',
        fontWeight: 700,
        height: '50px',
      }"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />

      <el-table-column prop="railWayName" label="所在铁路线" align="center" />

      <el-table-column
        prop="hundredMetersLoss"
        label="漏缆百米损耗"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="leakyCableCode"
        label="漏缆编号"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="leakyCableDescribe"
        label="描述"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="leakyCableLength"
        label="漏缆长度"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="leakyCableMode"
        label="漏缆型号"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="reductRatio"
        label="漏缆速度衰减系数："
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="sendPower"
        label="发射功率"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="jumperLength"
        label="跳线长度"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="inserterLength"
        label="插入器长度"
        show-overflow-tooltip
        align="center"
      />
      <el-table-column
        prop="antennaFeederLength"
        label="天馈线长度："
        align="center"
      />
      <el-table-column
        prop="action"
        label="详细信息"
        show-overflow-tooltip
        align="center"
      >
        <template slot-scope="{ row }">
          <el-link type="primary" :underline="false" @click="handleView(row)"
            >查看</el-link
          >
        </template>
      </el-table-column>
    </el-table>
    <pagination
      :limit="leakyCableForm.size"
      :page="leakyCableForm.current"
      :total="total"
      class="pagination"
      @pagination="handlePageChange"
    />
  </div>
</template>
<script>

import {
  leakyCablelist,
  leakyCablebatchDelete,
  leakyCabledetail,
} from "../../api";
import { cableTypeEnum } from "../../../maintain/api";
import { successAlert, warningAlert } from "@/utils/alert";
import { mapGetters, mapActions } from "vuex";
export default {
  props: [],
  components: {  },
  data() {
    return {
     
      railWaySelect: [],
      stationSelect2: [],
      fsuSelect2: [],
      equipTypeList:[],
      monitor2: [],
      leakyCableForm: {
        wayId: "",
        parentId: "",
        siteId: "",
        fsuId: "",
        monitor: "",
        leakyCableCode: "",
        leakyCableDescribe: "",
        leakyCableMode: "",
        current: 1,
        size: 10,
      },
      tableData: [],
      params: {
        pageNum: 1,
        pageSize: 10,
      },
      total: 10,
      multipleSelection: [],
      ids: [],
      block: 0,
      istrue:0
    };
  },
  computed: {
    ...mapGetters({
      railWaylist: "railWay/list",
      stationlist: "station/list",
      fsulist: "FSU/list",
      monitorEquiplist: "monitor/list",
    }),
  },
  methods: {
    ...mapActions({
      asyncrailWayList: "railWay/asyncList",
      asyncstationList: "station/asyncList",
      asyncfsuList: "FSU/asyncList",
      asyncmonitorList: "monitor/asyncList",
      asyncleakyList: "leaky/asyncList",
    }),
    changerailWay() {
      this.stationSelect2 = this.stationlist.filter(
        (item) => item.parentId === this.leakyCableForm.wayId
      );
    },
    changesite() {
      this.fsuSelect2 = this.fsulist.filter(
        (item) => item.parentId === this.leakyCableForm.siteId
      );
    },
    changefsu() {
      this.monitor2 = this.monitorEquiplist.filter(
        (item) => item.parentId === this.leakyCableForm.fsuId
      );
    },
    tableRowClassName({ row, rowIndex }) {
      return rowIndex % 2 === 0 ? "" : "single-row";
    },
    changeType(item) {
      this.activeName = item.key;
    },
    del() {
      let ids = this.ids;
      leakyCablebatchDelete({ ids }).then((res) => {
        if (res.code == 200) {
          successAlert("删除成功");
          this.asyncleakyList();
          this.getTableData();
        } else {
          warningAlert("删除失败");
        }
      });
    },
    refresh() {
      this.reset();
      this.getTableData();
    },
    searchQuery() {
      this.istrue=1
      this.getTableData();
    
    },
    reset() {
      this.leakyCableForm = {
        wayId: "",
        parentId: "",
        siteId: "",
        fsuId: "",
        monitor: "",
        leakyCableCode: "",
        leakyCableDescribe: "",

        leakyCableMode: "",
        current: 1,
        size: 10,
      };
    },

    exportData() {},
    handleSelectionChange(val) {
      this.multipleSelection = val;

      this.ids = this.multipleSelection.map((i) => i.id);
    },

    handleView(row) {
      this.$router.push({
        path: "/detail",
        query: {
          id: row.id,
          type: 5,
        },
      });
      let id = row.id;
      leakyCabledetail({ id }).then((res) => {});
    },
    handlePageChange(pageData) {
       this.leakyCableForm.size = pageData.size;
      this.leakyCableForm.current = pageData.page;
      this.getTableData();
    },
    getTableData() {
      let params = {
        current: this.params.pageNum,
        size: this.params.pageSize,
      };
      leakyCablelist(this.leakyCableForm).then((res) => {
        let list = res.records || [];
        this.tableData = list;
        this.total = res.total;
          if (this.istrue == 1) {
          if (this.tableData.length) {
            successAlert("查询成功");
          } else {
            warningAlert("查询结果为空");
          }
          this.istrue = 0;
        }
      });
    },
    getLeakyCablel() {
      cableTypeEnum().then((res) => {
        let list = res || [];
        this.equipTypeList = list;
      });
    },
  },
   created() {
    var that = this;
    document.onkeydown = function (e) {
      var key = window.event.keyCode;
      if (key == 13) {
        that.searchQuery();
      }
    };
  },
  mounted() {
    this.getTableData();
    this.asyncrailWayList();
    this.asyncstationList();
    this.asyncfsuList();
    this.asyncmonitorList();
    this.getLeakyCablel();
    this.railWaySelect = this.railWaylist;
    this.monitorSelect = this.monitorEquiplist;
  },
};
</script>
<style lang="scss" scoped>
.leakage-cable {
  .leakage-top {
    margin-bottom: 20px;
    display: flex;
    align-items: flex-end;
    justify-content: space-between;
  }
  & ::v-deep .cell {
    color: #333333;
  }
  & ::v-deep .stripe {
    background-color: #eaf1fe;
  }
  & ::v-deep .red {
    background-color: #f00;
  }
  & ::v-deep .green {
    background-color: green;
  }
  .page {
    display: flex;
    align-items: center;
    justify-content: center;
    margin: 20px 0;
    .pageNum {
      margin: 0 20px;
    }
  }
}
</style>
<style lang="scss">
.statistics-table {
  .single-row {
    background: #f1f6ff;
  }
  td {
    padding: 5px !important;
  }
}
</style>